<template>
  <div id="teacher_lecture_manage_wrapper" class="bt-container">
    <el-breadcrumb style="font-size: 24px; margin-top: 40px; margin-bottom: 40px;" separator="|">
      <el-breadcrumb-item :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentTeachingClass(classId) ? currentTeachingClass(classId).name : '' }}</el-breadcrumb-item>
      <el-breadcrumb-item>{{ lecture ? lecture.name : '' }}</el-breadcrumb-item>
      <div style="text-align: right;">
        <a href="javascript:history.back();">
          <el-button size="small">{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
        </a>
      </div> 
    </el-breadcrumb>
    <!-- <h2>{{ currentTeachingClass(classId) ? currentTeachingClass(classId).name : '' }} > {{ lecture ? lecture.name : '' }}</h2> -->
    <!-- lecture id: {{ lectureId }} {{ lecture }}<br /> <br /> -->
    <!-- ddd {{ currentTeachingClass(classId) }}<br /> -->

    <el-tabs v-model="activeTab" :before-leave="beforeLeaveTab" @tab-click="onClick('TAB_CLICK')">
      <el-tab-pane :label="$t('LECTURE_MANAGE.EDIT_INFO')" name="basic">
        <teacher-lecture-new />
      </el-tab-pane>
      <el-tab-pane :label="$t('LECTURE_MANAGE.MANAGE_KEYWORD')" name="keyword">
        <tlm-tab-material-and-keyword-edit
        v-if="activeTab==='keyword'"
        :onClick="onClick"/>
      </el-tab-pane>
      <el-tab-pane :label="$t('LECTURE_MANAGE.UPLOAD_VIDEO')" name="video">
        <tlm-tab-main-video-edit
        v-if="activeTab==='video'"/>
      </el-tab-pane>
      <el-tab-pane :label="$t('LECTURE_MANAGE.UPLOAD_MATERIAL')" name="material">
        <tlm-tab-material-edit
        v-if="activeTab==='material'"/>
      </el-tab-pane>
      <el-tab-pane :label="$t('LECTURE_MANAGE.EDIT_ITEM')" name="item">
        <tlm-tab-lecture-item-edit />
      </el-tab-pane>
      <el-tab-pane :label="$t('LECTURE_MANAGE.LECTURE_PROGRAM')" name="program">
        <tlm-tab-allowed-program
        v-if="activeTab==='program'"/>
      </el-tab-pane>
      <el-tab-pane :label="$t('LECTURE_MANAGE.KNOWLEDGE_MAP')" name="kmap" lazy>
        <knowledgeMap />
      </el-tab-pane>
      <el-tab-pane :label="$t('LECTURE_MANAGE.STUDENT_QUESTION')" name="submit">
        <student-submit-manage />
      </el-tab-pane>
      <el-tab-pane :label="$t('LECTURE_MANAGE.NEXT_SESSION')" name="connect">
        <connect-next-lecture/>
      </el-tab-pane>
      <!-- <el-tab-pane :label="$t('LECTURE_MANAGE.CONFERENCING')" name="conference">
        <el-button size="small" @click="realtimeSetting">{{ $t('DASHBOARD.REALTIME_SETTING') }}</el-button>
        <el-button size="small" @click="webCam()">{{ $t('DASHBOARD.REALTIME_FACE') }}</el-button>
      </el-tab-pane> -->
      <el-dialog
        :title="$t('DASHBOARD.REALTIME_SETTING')"
        :visible.sync="realtimeSettingViewSync.value"
        width="30%">
        <el-row>
          <el-radio v-model="realtimeType" label="0">{{ $t('REALTIME.PRESWOT') }}</el-radio>
          <el-radio v-model="realtimeType" label="1">{{ $t('REALTIME.OTHER_LINK') }}</el-radio>
          <span style="float: right; color: red; margin-right: 20px;">※ {{ $t('REALTIME.REALTIME_SETTING_MSG')}}</span>
        </el-row>
        <el-row v-if="realtimeType === '1'">
          <el-col :span="2">
            <span style="line-height: 200%;">URL</span>
          </el-col>
          <el-col :span="16">
            <el-input v-model="realtimeOtherLink" size="small"></el-input>
          </el-col>
          <el-col :span="4">
            <el-button type="primary" size="small" style="margin-left: 10px;" @click="openInNewTab(realtimeOtherLink)">{{ $t('REALTIME.ACCESS') }}</el-button>
          </el-col>
        </el-row>
      </el-dialog>
    </el-tabs>
  </div>
</template>

<script>
import { mapState, mapActions, mapGetters, mapMutations } from 'vuex';
import authService from '../../services/authService';
import NNTeacherLectureNew from './NNTeacherLectureNew';
import TlmTabMaterialAndKeywordEdit from '../partials/TlmTabMaterialAndKeywordEdit';
import TlmTabLectureItemEdit from '../partials/TlmTabLectureItemEdit';
import TlmTabAllowedProgram from '../partials/TlmTabAllowedProgram';
import TlmTabMaterialEdit from '../partials/TlmTabMaterialEdit';
import TlmTabMainVideoEdit from '../partials/TlmTabMainVideoEdit';
import StudentSubmitManage from '../partials/StudentSubmitManage';
import ConnectNextLecture from '../partials/ConnectNextLecture';
// import utils from '../../utils';
// import MaterialUpload from '../partials/MaterialUpload';
// import RecommendKeywords from '../partials/RecommendKeywords';
// import LectureKeywordsEditor from '../partials/LectureKeywordsEditor';
import KnowledgeMap from '../partials/NNKnowledgeMap';
import { EventBus } from '../../event-bus';
import utils from '../../utils';
import lectureService from '../../services/lectureService';


export default {
  name: 'TeacherLectureManage',
  components: {
    TeacherLectureNew: NNTeacherLectureNew,
    TlmTabMaterialAndKeywordEdit,
    TlmTabMaterialEdit,
    TlmTabMainVideoEdit,
    TlmTabLectureItemEdit,
    TlmTabAllowedProgram,
    StudentSubmitManage,
    KnowledgeMap,
    ConnectNextLecture,
  },
  data() {
    const vm = this;
    return {
      activeTab: 'basic',
      realtimeSettingViewSync: {
        _value: false,
        type: 'boolean',
        get value() {
          return this._value;
        },
        set value(value) {
          if (typeof value === this.type) {
            this._value = value;
          }
          if (value === false) {
            vm.setRealtimeWebcamSession();
          }
        }
      },
      realtimeType: '0',
      realtimeOtherLink: '',
    };
  },
  mounted() {
    const vm = this;
    vm.activeTab = vm.$store.state.lectureEditTab.tab || 'basic';
    vm.updateTab({
      tab: 'basic',
    });
  },
  async created() {
    const vm = this;
    // FIXME: TeacherClassShow의 그것이랑 동일한 문제 // getMyClassLists를 다른곳에서 불러서 이미 채워져있는경우면 사실 필요없음
    // 학생이 url로 접근하는 경우 방지
    const accessId = utils.getUserIdFromJwt();
    const accessCheck = await authService.returnUserInfo({
      userID: accessId,
    });
    if (accessCheck.data.userInfo.type === 0) {
      vm.$router.push({ name: 'LandingPage' });
    }
    await vm.getMyClassLists();
    await vm.getClass({
      type: 'TEACHER',
      classId: vm.classId,
    });
    await vm.getLecture({ lectureId: vm.lectureId });
    await vm.getKeywords();

    vm.realtimeOtherLink = vm.lecture.webcam_link;
    vm.realtimeType = vm.lecture.webcam_link === '' ? '0' : '1';
  },
  beforeRouteLeave(to, from, next) {
    const vm = this;
    vm.resetLectureItemEditTab();
    next();
  },
  computed: {
    ...mapGetters('NNclass', [
      'currentTeachingClass',
    ]),
    ...mapState('lc', [
      'lecture',
    ]),
    ...mapState('lectureEditTab', [
      'tab'
    ]),
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.query.classId, 10);
    },
    lectureId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.lectureId, 10);
    },
  },
  methods: {
    ...mapMutations('lcItem', [
      'updateCurrentEditingLectureItemId',
      'updateLectureItem',
    ]),
    ...mapActions('NNclass', [
      'getMyClassLists',
      'getClass',
    ]),
    ...mapActions('lc', [
      'getLecture',
    ]),
    ...mapActions('keyword', [
      'deleteLectureKeywords',
      'postLectureKeywords',
      'getKeywords',
    ]),
    ...mapMutations('lectureEditTab', [
      'updateTab',
    ]),
    beforeLeaveTab() {
      const vm = this;
      if (vm.activeTab === 'item') { // 강의 아이템 등록에서 떠나려는 경우
        vm.resetLectureItemEditTab();
      }
      return true; // false인 경우 탭 전환 안됨
    },
    resetLectureItemEditTab() {
      const vm = this;
      vm.updateCurrentEditingLectureItemId({
        currentEditingLectureItemId: null,
      });
      vm.updateLectureItem({
        lectureItem: null,
      });
    },
    onClick(type) {
      const vm = this;
      switch (type) {
        case 'SUBMIT_KEYWORDS': {
          vm.deleteLectureKeywords();
          vm.postLectureKeywords();
          break;
        }
        case 'TAB_CLICK': {
          if (vm.activeTab === 'kmap') {
            EventBus.$emit('drawNetwork');
          }
          if (vm.activeTab === 'keyword') {
            EventBus.$emit('clearKeywordTab');
          }
          break;
        }
        default: {
          throw new Error(`not defined type ${type}`);
        }
      }
    },
    realtimeSetting() {
      const vm = this;
      vm.realtimeSettingViewSync.value = true;
    },
    webCam() {
      const vm = this;
      let url = vm.realtimeOtherLink;
      if (url === '') {
        let routeData = vm.$router.resolve({path: '/a/webcam' + `/${vm.lectureId}/${vm.classId}`});
        window.open(routeData.href, '_blank');
      } else {
        vm.openInNewTab(url);
      }
    },
    openInNewTab(url) {
      if (!url.match(/^https?:\/\//i)) {
        url = 'http://' + url;
      }
      window.open(url, '_blank').focus();
    },
    async setRealtimeWebcamSession() {
      const vm = this;
      // setDB
      if (vm.realtimeType === '0') {
        vm.realtimeOtherLink = '';
      }
      
      const res = await lectureService.putLecture({
        lecture_id: vm.lectureId,
        webcam_link: vm.realtimeOtherLink,
      });
      
      if (res.data.success) {
        if (vm.realtimeOtherLink === '') {
          vm.$notify({
            title: vm.$t('DASHBOARD.REALTIME_SETTING'),
            message: vm.$t('DASHBOARD.REALTIME_SETTING_MSG_1'),
            type: 'success',
          });
        } else {
          vm.$notify({
            title: vm.$t('DASHBOARD.REALTIME_SETTING'),
            message: vm.$t('DASHBOARD.REALTIME_SETTING_MSG_2'),
            type: 'success',
          });
        }
      } else {
        vm.$notify({
          title: vm.$t('DASHBOARD.REALTIME_SETTING'),
          message: vm.$t('DASHBOARD.REALTIME_SETTING_ERROR'),
          type: 'error',
        });
      }

      const params = {
        lecture_id: vm.lectureId,
        user_id: utils.getUserIdFromJwt()
      };
      // refresh student
      vm.$socket.emit('REFRESH_ALL_STUDENT', JSON.stringify(params));
    },
  },
};
</script>

<style lang="scss" scoped>
#teacher_lecture_manage_wrapper {
  .align-right {
    text-align: right;
  }
}
</style>


